lens-5.3.3: Lenses, Folds and Traversals

Copyright | (C) 2014-2016 Edward Kmett (C) 2014 Eric Mertens
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | Safe
Language | Haskell2010

Control.Lens.Internal.FieldTH

Description

Synopsis

- data LensRules = LensRules {
  - _simpleLenses :: Bool
  - _generateSigs :: Bool
  - _generateClasses :: Bool
  - _allowIsos :: Bool
  - _allowUpdates :: Bool
  - _lazyPatterns :: Bool
  - _recordSyntax :: Bool
  - _fieldToDef :: FieldNamer
  - _classyLenses :: ClassyNamer
  }
- type FieldNamer = Name -> [Name] -> Name -> [DefName]
- data DefName
  - = TopName Name
  - | MethodName Name Name
- type ClassyNamer = Name -> Maybe (Name, Name)
- makeFieldOptics :: LensRules -> Name -> DecsQ
- makeFieldOpticsForDec :: LensRules -> Dec -> DecsQ
- makeFieldOpticsForDec' :: LensRules -> Dec -> HasFieldClasses [Dec]
- type HasFieldClasses = StateT (Set Name) Q

# Documentation

data LensRules #

Rules to construct lenses for data fields.

Constructors

LensRules |

Fields

- _simpleLenses :: Bool
- _generateSigs :: Bool
- _generateClasses :: Bool
- _allowIsos :: Bool
- _allowUpdates :: Bool

  Allow LensTraversal (otherwise GetterFold)

- _lazyPatterns :: Bool
- _recordSyntax :: Bool
- _fieldToDef :: FieldNamer

  Type Name -> Field Names -> Target Field Name -> Definition Names

- _classyLenses :: ClassyNamer

type FieldNamer #

Arguments

= Name | Name of the data type that lenses are being generated for.
-> [Name] | Names of all fields (including the field being named) in the data type.
-> Name | Name of the field being named.
-> [DefName] | Name(s) of the lens functions. If empty, no lens is created for that field.

The rule to create function names of lenses for data fields.

Although it's sometimes useful, you won't need the first two arguments most of the time.

data DefName #

Name to give to generated field optics.

Constructors

TopName Name | Simple top-level definition name
MethodName Name Name | makeFields-style class name and method name

#### Instances

Instances details

Show DefName # |
Instance details Defined in Control.Lens.Internal.FieldTH Methods showsPrec :: Int -> DefName -> ShowS # show :: DefName -> String # showList :: [DefName] -> ShowS #
Eq DefName # |
Instance details Defined in Control.Lens.Internal.FieldTH Methods (==) :: DefName -> DefName -> Bool # (/=) :: DefName -> DefName -> Bool #
Ord DefName # |
Instance details Defined in Control.Lens.Internal.FieldTH Methods compare :: DefName -> DefName -> Ordering # (<) :: DefName -> DefName -> Bool # (<=) :: DefName -> DefName -> Bool # (>) :: DefName -> DefName -> Bool # (>=) :: DefName -> DefName -> Bool # max :: DefName -> DefName -> DefName # min :: DefName -> DefName -> DefName #

type ClassyNamer #

Arguments

= Name | Name of the data type that lenses are being generated for.
-> Maybe (Name, Name) | Names of the class and the main method it generates, respectively.

The optional rule to create a class and method around a monomorphic data type. If this naming convention is provided, it generates a "classy" lens.

makeFieldOptics :: LensRules -> Name -> DecsQ #

Compute the field optics for the type identified by the given type name. Lenses will be computed when possible, Traversals otherwise.

makeFieldOpticsForDec :: LensRules -> Dec -> DecsQ #

makeFieldOpticsForDec' :: LensRules -> Dec -> HasFieldClasses [Dec] #

type HasFieldClasses = StateT (Set Name) Q #

Tracks the field class `Name`s that have been created so far. We consult these so that we may avoid creating duplicate classes.